--- old/usr/src/head/wctype.h	Tue May 20 07:58:45 2014
+++ new/usr/src/head/wctype.h	Tue May 20 07:58:45 2014
@@ -24,6 +24,7 @@
 /*	definitions for international functions	*/
 
 /*
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  * Copyright 2003 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
@@ -31,11 +32,9 @@
 #ifndef	_WCTYPE_H
 #define	_WCTYPE_H
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
+#include <sys/feature_tests.h>
 #include <iso/wctype_iso.h>
-#if !defined(__XOPEN_OR_POSIX) && !defined(_STRICT_STDC) || \
-	defined(__EXTENSIONS__)
+#ifndef _STRICT_SYMBOLS
 #include <ctype.h>
 #include <wchar.h>
 #endif
@@ -64,22 +63,17 @@
 using std::towctrans;
 using std::iswctype;
 using std::wctype;
+#if __cplusplus >= 201103L
+using std::iswblank;
 #endif
+#endif
 
-/*
- * This header needs to be included here because it relies on the global
- * visibility of wint_t in the C++ environment.
- */
-
-#include <iso/wctype_c99.h>
-
 #ifdef	__cplusplus
 extern "C" {
 #endif
 
 /* do not allow any of the following in a strictly conforming application */
-#if !defined(__XOPEN_OR_POSIX) && !defined(_STRICT_STDC) || \
-	defined(__EXTENSIONS__)
+#ifndef _STRICT_SYMBOLS
 
 /*
  * data structure for supplementary code set
@@ -111,8 +105,6 @@
 /* isw*, except iswascii(), are not macros any more.  They become functions */
 #ifdef __STDC__
 
-extern	unsigned _iswctype(wchar_t, int);
-extern	wchar_t _trwctype(wchar_t, int);
 /* is* also become functions */
 extern	int isphonogram(wint_t);
 extern	int isideogram(wint_t);
@@ -119,10 +111,14 @@
 extern	int isenglish(wint_t);
 extern	int isnumber(wint_t);
 extern	int isspecial(wint_t);
-#else
+/* From BSD/MacOS */
+extern	int iswideogram(wint_t);
+extern	int iswphonogram(wint_t);
+extern	int iswnumber(wint_t);
+extern	int iswspecial(wint_t);
 
-extern  unsigned _iswctype();
-extern  wchar_t _trwctype();
+#else	/* __STDC__ */
+
 /* is* also become functions */
 extern  int isphonogram();
 extern  int isideogram();
@@ -129,6 +125,11 @@
 extern  int isenglish();
 extern  int isnumber();
 extern  int isspecial();
+/* From BSD/MacOS */
+extern	int iswideogram();
+extern	int iswphonogram();
+extern	int iswnumber();
+extern	int iswspecial();
 #endif
 
 #define	iscodeset0(c)	isascii(c)
@@ -136,8 +137,56 @@
 #define	iscodeset2(c)	(((c) & WCHAR_CSMASK) == WCHAR_CS2)
 #define	iscodeset3(c)	(((c) & WCHAR_CSMASK) == WCHAR_CS3)
 
-#endif /* !defined(__XOPEN_OR_POSIX)... */
+#endif /* !defined(_STRICT_SYMBOLS)... */
 
+
+/* XPG7 extended locale support */
+#if defined(_XPG7) || !defined(_STRICT_SYMBOLS)
+
+#ifndef	_LOCALE_T
+#define	_LOCALE_T
+typedef struct locale *locale_t;
+#endif
+
+#if	defined(__STDC__)
+extern wint_t towlower_l(wint_t, locale_t);
+extern wint_t towupper_l(wint_t, locale_t);
+extern wint_t towctrans_l(wint_t, wctrans_t, locale_t);
+extern int iswctype_l(wint_t, wctype_t, locale_t);
+extern int iswalnum_l(wint_t, locale_t);
+extern int iswalpha_l(wint_t, locale_t);
+extern int iswcntrl_l(wint_t, locale_t);
+extern int iswdigit_l(wint_t, locale_t);
+extern int iswgraph_l(wint_t, locale_t);
+extern int iswlower_l(wint_t, locale_t);
+extern int iswprint_l(wint_t, locale_t);
+extern int iswpunct_l(wint_t, locale_t);
+extern int iswspace_l(wint_t, locale_t);
+extern int iswupper_l(wint_t, locale_t);
+extern int iswxdigit_l(wint_t, locale_t);
+extern wctrans_t wctrans_l(const char *, locale_t);
+extern wctype_t wctype_l(const char *, locale_t);
+#else	/* __STDC__ */
+extern wint_t towlower_l();
+extern wint_t towupper_l();
+extern wint_t towctrans_l();
+extern int iswctype_l();
+extern int iswalnum_l();
+extern int iswalpha_l();
+extern int iswcntrl_l();
+extern int iswdigit_l();
+extern int iswgraph_l();
+extern int iswlower_l();
+extern int iswprint_l();
+extern int iswpunct_l();
+extern int iswspace_l();
+extern int iswupper_l();
+extern int iswxdigit_l();
+extern wctrans_t wctrans_l();
+extern wctype_t wctype_l();
+#endif	/* __STDC__ */
+#endif /* defined(_XPG7) || !defined(_STRICT_SYMBOLS) */
+
 #ifdef	__cplusplus
 }
 #endif
--- /dev/null	Tue May 20 07:58:45 2014
+++ new/usr/src/head/xlocale.h	Tue May 20 07:58:45 2014
@@ -0,0 +1,113 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
+ */
+
+#ifndef _XLOCALE_H
+#define	_XLOCALE_H
+
+/*
+ * This file supplies declarations for extended locale routines, as
+ * originally delivered by MacOS X.  Many of these things are now
+ * officially part of XPG7.  (Note that while the interfaces are the
+ * same as MacOS X, there is no shared implementation.)
+ *
+ * Those declarations that are part of XPG7 are provided for the in the
+ * XPG7-specified location.  This file lists just the declarations that
+ * were not part of the standard.  These will be useful in their own right,
+ * and will aid porting programs that don't strictly follow the standard.
+ *
+ * Note that it is an error to include this file in a program with strict
+ * symbol visibilty rules (under strict ANSI or POSIX_C_SOURCE rules.)
+ * If this is done, the symbols defined here will indeed be exposed to your
+ * program, but those symbols that are part of the related standards might
+ * not be.
+ */
+
+#include <sys/feature_tests.h>
+#include <wchar.h>
+#include <locale.h>
+#include <stdio.h>
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#ifndef	_LOCALE_T
+#define	_LOCALE_T
+typedef struct locale *locale_t;
+#endif
+
+int mbsinit_l(const mbstate_t *, locale_t);
+
+size_t mbsrtowcs_l(wchar_t *_RESTRICT_KYWD, const char **_RESTRICT_KYWD,
+    size_t, mbstate_t *_RESTRICT_KYWD, locale_t);
+
+size_t mbsnrtowcs_l(wchar_t *_RESTRICT_KYWD, const char **_RESTRICT_KYWD,
+    size_t, size_t, mbstate_t *_RESTRICT_KYWD, locale_t);
+
+char *strptime_l(const char *_RESTRICT_KYWD, const char *_RESTRICT_KYWD,
+    struct tm *_RESTRICT_KYWD, locale_t);
+
+int wcwidth_l(wchar_t, locale_t);
+
+int wcswidth_l(const wchar_t *, size_t, locale_t);
+
+int iswspecial_l(wint_t, locale_t);
+int iswnumber_l(wint_t, locale_t);
+int iswhexnumber_l(wint_t, locale_t);
+int iswideogram_l(wint_t, locale_t);
+int iswphonogram_l(wint_t, locale_t);
+
+wint_t btowc_l(int, locale_t);
+int wctob_l(wint_t, locale_t);
+size_t mbrtowc_l(wchar_t *_RESTRICT_KYWD, const char *_RESTRICT_KYWD, size_t,
+    mbstate_t *_RESTRICT_KYWD, locale_t);
+size_t mbstowcs_l(wchar_t *_RESTRICT_KYWD, const char *_RESTRICT_KYWD, size_t,
+    locale_t);
+int mblen_l(const char *, size_t, locale_t);
+size_t mbrlen_l(const char *_RESTRICT_KYWD, size_t, mbstate_t *_RESTRICT_KYWD,
+    locale_t);
+int mbtowc_l(wchar_t *_RESTRICT_KYWD, const char *_RESTRICT_KYWD, size_t,
+    locale_t);
+size_t wcsrtombs_l(char *_RESTRICT_KYWD, const wchar_t **_RESTRICT_KYWD,
+    size_t len, mbstate_t *_RESTRICT_KYWD, locale_t);
+size_t wcrtomb_l(char *_RESTRICT_KYWD, wchar_t, mbstate_t *_RESTRICT_KYWD,
+    locale_t);
+size_t wcstombs_l(char *_RESTRICT_KYWD, const wchar_t *_RESTRICT_KYWD, size_t,
+    locale_t);
+int wctomb_l(char *, wchar_t, locale_t);
+
+unsigned char __mb_cur_max_l(locale_t);
+#ifndef	MB_CUR_MAX_L
+#define	MB_CUR_MAX_L(l)	(__mb_cur_max_l(l))
+#endif
+
+
+#if defined(_XPG4) && !defined(_FILEDEFED) || __cplusplus >= 199711L
+#define	_FILEDEFED
+typedef __FILE FILE;
+#endif
+
+wint_t fgetwc_l(FILE *, locale_t);
+wint_t getwc_l(FILE *, locale_t);
+
+#ifndef getwchar_l
+#define	getwchar_l(l)	fgetwc_l(stdin, (l))
+#endif
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* _XLOCALE_H */
--- old/usr/src/lib/libc/amd64/Makefile	Tue May 20 07:58:46 2014
+++ new/usr/src/lib/libc/amd64/Makefile	Tue May 20 07:58:46 2014
@@ -23,6 +23,7 @@
 # Copyright (c) 2012, Joyent, Inc. All rights reserved.
 #
 # Copyright (c) 2013, OmniTI Computer Consulting, Inc. All rights reserved.
+# Copyright 2013 Garrett D'Amore <garrett@damore.org>
 # Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
@@ -655,9 +656,6 @@
 	getwchar.o		\
 	putwchar.o		\
 	putws.o			\
-	strcasecmp.o		\
-	strcasestr.o		\
-	strncasecmp.o		\
 	strtows.o		\
 	wcsnlen.o		\
 	wcsstr.o		\
@@ -670,7 +668,6 @@
 	wmemcpy.o		\
 	wmemmove.o		\
 	wmemset.o		\
-	wscasecmp.o		\
 	wscat.o			\
 	wschr.o			\
 	wscmp.o			\
@@ -678,7 +675,6 @@
 	wscspn.o		\
 	wsdup.o			\
 	wslen.o			\
-	wsncasecmp.o		\
 	wsncat.o		\
 	wsncmp.o		\
 	wsncpy.o		\
@@ -696,7 +692,6 @@
 	gettext_gnu.o		\
 	gettext_real.o		\
 	gettext_util.o		\
-	isdigit.o		\
 	plural_parser.o		\
 	wdresolve.o		\
 	_ctype.o		\
@@ -724,6 +719,7 @@
 	gb2312.o		\
 	gbk.o			\
 	getdate.o		\
+	isdigit.o		\
 	iswctype.o		\
 	ldpart.o		\
 	lmessages.o		\
@@ -730,6 +726,7 @@
 	lnumeric.o		\
 	lmonetary.o		\
 	localeconv.o		\
+	localeimpl.o		\
 	mbftowc.o		\
 	mblen.o			\
 	mbrlen.o		\
@@ -751,9 +748,12 @@
 	runetype.o		\
 	setlocale.o		\
 	setrunelocale.o		\
+	strcasecmp.o		\
+	strcasestr.o		\
 	strcoll.o		\
 	strfmon.o		\
 	strftime.o		\
+	strncasecmp.o		\
 	strptime.o		\
 	strxfrm.o		\
 	table.o			\
@@ -763,6 +763,7 @@
 	ungetwc.o		\
 	utf8.o			\
 	wcrtomb.o		\
+	wcscasecmp.o		\
 	wcscoll.o		\
 	wcsftime.o		\
 	wcsnrtombs.o		\
--- old/usr/src/lib/libc/i386/Makefile.com	Tue May 20 07:58:46 2014
+++ new/usr/src/lib/libc/i386/Makefile.com	Tue May 20 07:58:46 2014
@@ -22,6 +22,7 @@
 # Copyright (c) 2004, 2010, Oracle and/or its affiliates. All rights reserved.
 # Copyright (c) 2013, Joyent, Inc.  All rights reserved.
 # Copyright (c) 2013, OmniTI Computer Consulting, Inc. All rights reserved.
+# Copyright 2013 Garrett D'Amore <garrett@damore.org>
 #
 # Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
 # Use is subject to license terms.
@@ -697,9 +698,6 @@
 	getwchar.o		\
 	putwchar.o		\
 	putws.o			\
-	strcasecmp.o		\
-	strcasestr.o		\
-	strncasecmp.o		\
 	strtows.o		\
 	wcsnlen.o		\
 	wcsstr.o		\
@@ -712,7 +710,6 @@
 	wmemcpy.o		\
 	wmemmove.o		\
 	wmemset.o		\
-	wscasecmp.o		\
 	wscat.o			\
 	wschr.o			\
 	wscmp.o			\
@@ -720,7 +717,6 @@
 	wscspn.o		\
 	wsdup.o			\
 	wslen.o			\
-	wsncasecmp.o		\
 	wsncat.o		\
 	wsncmp.o		\
 	wsncpy.o		\
@@ -738,7 +734,6 @@
 	gettext_gnu.o		\
 	gettext_real.o		\
 	gettext_util.o		\
-	isdigit.o		\
 	plural_parser.o		\
 	wdresolve.o		\
 	_ctype.o		\
@@ -766,6 +761,7 @@
 	gb2312.o		\
 	gbk.o			\
 	getdate.o		\
+	isdigit.o		\
 	iswctype.o		\
 	ldpart.o		\
 	lmessages.o		\
@@ -772,6 +768,7 @@
 	lnumeric.o		\
 	lmonetary.o		\
 	localeconv.o		\
+	localeimpl.o		\
 	mbftowc.o		\
 	mblen.o			\
 	mbrlen.o		\
@@ -793,9 +790,12 @@
 	runetype.o		\
 	setlocale.o		\
 	setrunelocale.o		\
+	strcasecmp.o		\
+	strcasestr.o		\
 	strcoll.o		\
 	strfmon.o		\
 	strftime.o		\
+	strncasecmp.o		\
 	strptime.o		\
 	strxfrm.o		\
 	table.o			\
@@ -805,6 +805,7 @@
 	ungetwc.o		\
 	utf8.o			\
 	wcrtomb.o		\
+	wcscasecmp.o		\
 	wcscoll.o		\
 	wcsftime.o		\
 	wcsnrtombs.o		\
--- old/usr/src/lib/libc/port/locale/_ctype.h	Tue May 20 07:58:46 2014
+++ new/usr/src/lib/libc/port/locale/_ctype.h	Tue May 20 07:58:46 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 1989, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -79,6 +80,4 @@
 #define	_CTYPE_SWM	0xe0000000U		/* Mask for screen width data */
 #define	_CTYPE_SWS	30			/* Bits to shift to get width */
 
-unsigned int	___runetype(int);
-
 #endif /* !__CTYPE_H_ */
--- old/usr/src/lib/libc/port/locale/big5.c	Tue May 20 07:58:46 2014
+++ new/usr/src/lib/libc/port/locale/big5.c	Tue May 20 07:58:46 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins. All rights reserved.
  * Copyright (c) 1993
@@ -35,11 +36,11 @@
 #include "lint.h"
 #include <sys/types.h>
 #include <errno.h>
-#include "runetype.h"
 #include <stdlib.h>
 #include <string.h>
 #include <wchar.h>
 #include "mblocal.h"
+#include "lctype.h"
 
 static size_t	_BIG5_mbrtowc(wchar_t *_RESTRICT_KYWD,
 		    const char *_RESTRICT_KYWD,
@@ -47,22 +48,27 @@
 static int	_BIG5_mbsinit(const mbstate_t *);
 static size_t	_BIG5_wcrtomb(char *_RESTRICT_KYWD, wchar_t,
 		    mbstate_t *_RESTRICT_KYWD);
+static size_t	_BIG5_mbsnrtowcs(wchar_t *_RESTRICT_KYWD,
+		    const char **_RESTRICT_KYWD, size_t, size_t,
+		    mbstate_t *_RESTRICT_KYWD);
+static size_t	_BIG5_wcsnrtombs(char *_RESTRICT_KYWD,
+		    const wchar_t **_RESTRICT_KYWD, size_t, size_t,
+		    mbstate_t *_RESTRICT_KYWD);
 
 typedef struct {
 	wchar_t	ch;
 } _BIG5State;
 
-int
-_BIG5_init(_RuneLocale *rl)
+void
+_BIG5_init(struct lc_ctype *lct)
 {
-
-	__mbrtowc = _BIG5_mbrtowc;
-	__wcrtomb = _BIG5_wcrtomb;
-	__mbsinit = _BIG5_mbsinit;
-	_CurrentRuneLocale = rl;
-	__ctype[520] = 2;
-	charset_is_ascii = 0;
-	return (0);
+	lct->lc_mbrtowc = _BIG5_mbrtowc;
+	lct->lc_wcrtomb = _BIG5_wcrtomb;
+	lct->lc_mbsnrtowcs = _BIG5_mbsnrtowcs;
+	lct->lc_wcsnrtombs = _BIG5_wcsnrtombs;
+	lct->lc_mbsinit = _BIG5_mbsinit;
+	lct->lc_max_mblen = 2;
+	lct->lc_is_ascii = 0;
 }
 
 static int
@@ -163,4 +169,18 @@
 	}
 	*s = wc & 0xff;
 	return (1);
+}
+
+static size_t
+_BIG5_mbsnrtowcs(wchar_t *_RESTRICT_KYWD dst, const char **_RESTRICT_KYWD src,
+    size_t nms, size_t len, mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (__mbsnrtowcs_std(dst, src, nms, len, ps, _BIG5_mbrtowc));
+}
+
+static size_t
+_BIG5_wcsnrtombs(char *_RESTRICT_KYWD dst, const wchar_t **_RESTRICT_KYWD src,
+    size_t nwc, size_t len, mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (__wcsnrtombs_std(dst, src, nwc, len, ps, _BIG5_wcrtomb));
 }
--- old/usr/src/lib/libc/port/locale/btowc.c	Tue May 20 07:58:46 2014
+++ new/usr/src/lib/libc/port/locale/btowc.c	Tue May 20 07:58:46 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002, 2003 Tim J. Robbins.
  * All rights reserved.
@@ -28,10 +29,12 @@
 #include "lint.h"
 #include <stdio.h>
 #include <wchar.h>
+#include <locale.h>
+#include <xlocale.h>
 #include "mblocal.h"
 
 wint_t
-btowc(int c)
+btowc_l(int c, locale_t loc)
 {
 	static const mbstate_t initial = { 0 };
 	mbstate_t mbs = initial;
@@ -46,7 +49,13 @@
 	 * counts.
 	 */
 	cc = (char)c;
-	if (__mbrtowc(&wc, &cc, 1, &mbs) > 1)
+	if (mbrtowc_l(&wc, &cc, 1, &mbs, loc) > 1)
 		return (WEOF);
 	return (wc);
+}
+
+wint_t
+btowc(int c)
+{
+	return (btowc_l(c, uselocale(NULL)));
 }
--- old/usr/src/lib/libc/port/locale/collate.c	Tue May 20 07:58:46 2014
+++ new/usr/src/lib/libc/port/locale/collate.c	Tue May 20 07:58:46 2014
@@ -1,5 +1,6 @@
 /*
- * Copright 2010 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
+ * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 1995 Alex Tatmanjants <alex@elvisti.kiev.ua>
  *		at Electronni Visti IA, Kiev, Ukraine.
  *			All rights reserved.
@@ -44,7 +45,6 @@
 
 #include "collate.h"
 #include "setlocale.h"
-#include "ldpart.h"
 
 /*
  * See the comments in usr/src/cmd/localedef/collate.c for further
@@ -53,21 +53,22 @@
  * handy (www.opengroup.org).
  */
 
-static collate_subst_t		*subst_table[COLL_WEIGHTS_MAX];
-static collate_char_t		*char_pri_table;
-static collate_large_t		*large_pri_table;
-static collate_chain_t		*chain_pri_table;
-static char			*cache = NULL;
-static size_t			cachesz;
-static char			collate_encoding[ENCODING_LEN + 1];
+/*
+ * POSIX uses empty tables and falls down to strcmp.
+ */
+struct lc_collate lc_collate_posix = {
+	.lc_is_posix = 1,
+};
 
-/* Exposed externally to other parts of libc. */
-collate_info_t			*_collate_info;
-int _collate_load_error = 1;
+struct locdata __posix_collate_locdata = {
+	.l_lname = "C",
+	.l_refcnt = (uint32_t)-1,
+	.l_data = { &lc_collate_posix }
+};
 
 
-int
-_collate_load_tables(const char *encoding)
+struct locdata *
+__lc_collate_load(const char *locname)
 {
 	int i, chains, z;
 	char buf[PATH_MAX];
@@ -76,49 +77,41 @@
 	collate_info_t *info;
 	struct stat sbuf;
 	int fd;
+	struct locdata *ldata;
+	struct lc_collate *lcc;
 
-	/* 'encoding' must be already checked. */
-	if (strcmp(encoding, "C") == 0 || strcmp(encoding, "POSIX") == 0) {
-		_collate_load_error = 1;
-		return (_LDP_CACHE);
-	}
-
 	/*
-	 * If the locale name is the same as our cache, use the cache.
-	 */
-	if (cache && (strncmp(encoding, collate_encoding, ENCODING_LEN) == 0)) {
-		_collate_load_error = 0;
-		return (_LDP_CACHE);
-	}
-
-	/*
 	 * Slurp the locale file into the cache.
 	 */
 
 	(void) snprintf(buf, sizeof (buf), "%s/%s/LC_COLLATE/LCL_DATA",
-	    _PathLocale, encoding);
+	    _PathLocale, locname);
 
-	if ((fd = open(buf, O_RDONLY)) < 0)
-		return (_LDP_ERROR);
+	if ((fd = open(buf, O_RDONLY)) < 0) {
+		errno = EINVAL;
+		return (NULL);
+	}
 	if (fstat(fd, &sbuf) < 0) {
 		(void) close(fd);
-		return (_LDP_ERROR);
+		errno = EINVAL;
+		return (NULL);
 	}
 	if (sbuf.st_size < (COLLATE_STR_LEN + sizeof (info))) {
 		(void) close(fd);
 		errno = EINVAL;
-		return (_LDP_ERROR);
+		return (NULL);
 	}
 	map = mmap(NULL, sbuf.st_size, PROT_READ, MAP_PRIVATE, fd, 0);
 	(void) close(fd);
 	if ((TMP = map) == NULL) {
-		return (_LDP_ERROR);
+		errno = EINVAL;
+		return (NULL);
 	}
 
 	if (strncmp(TMP, COLLATE_VERSION, COLLATE_STR_LEN) != 0) {
 		(void) munmap(map, sbuf.st_size);
 		errno = EINVAL;
-		return (_LDP_ERROR);
+		return (NULL);
 	}
 	TMP += COLLATE_STR_LEN;
 
@@ -130,72 +123,84 @@
 	    ((chains = info->chain_count) < 0)) {
 		(void) munmap(map, sbuf.st_size);
 		errno = EINVAL;
-		return (_LDP_ERROR);
+		return (NULL);
 	}
 
 	i = (sizeof (collate_char_t) * (UCHAR_MAX + 1)) +
 	    (sizeof (collate_chain_t) * chains) +
 	    (sizeof (collate_large_t) * info->large_count);
-	for (z = 0; z < (info->directive_count); z++) {
+	for (z = 0; z < info->directive_count; z++) {
 		i += sizeof (collate_subst_t) * info->subst_count[z];
 	}
 	if (i != (sbuf.st_size - (TMP - map))) {
 		(void) munmap(map, sbuf.st_size);
 		errno = EINVAL;
-		return (_LDP_ERROR);
+		return (NULL);
 	}
 
-	char_pri_table = (void *)TMP;
+
+	if ((ldata = __locdata_alloc(locname, sizeof (*lcc))) == NULL) {
+		(void) munmap(map, sbuf.st_size);
+		return (NULL);
+	}
+	lcc = ldata->l_data[0];
+	ldata->l_map = map;
+	ldata->l_map_len = sbuf.st_size;
+
+	lcc->lc_info = info;
+	lcc->lc_directive_count = info->directive_count;
+	lcc->lc_large_count = info->large_count;
+
+	for (z = 0; z < COLL_WEIGHTS_MAX; z++) {
+		lcc->lc_directive[z] = info->directive[z];
+		lcc->lc_subst_count[z] = info->subst_count[z];
+		lcc->lc_pri_count[z] = info->pri_count[z];
+		lcc->lc_undef_pri[z] = info->undef_pri[z];
+	}
+
+	lcc->lc_char_table = (void *)TMP;
 	TMP += sizeof (collate_char_t) * (UCHAR_MAX + 1);
 
-	for (z = 0; z < info->directive_count; z++) {
-		if (info->subst_count[z] > 0) {
-			subst_table[z] = (void *)TMP;
-			TMP += info->subst_count[z] * sizeof (collate_subst_t);
+	for (z = 0; z < lcc->lc_directive_count; z++) {
+		int count;
+		if ((count = lcc->lc_subst_count[z]) > 0) {
+			lcc->lc_subst_table[z] = (void *)TMP;
+			TMP += count * sizeof (collate_subst_t);
 		} else {
-			subst_table[z] = NULL;
+			lcc->lc_subst_table[z] = NULL;
 		}
 	}
 
 	if (chains > 0) {
-		chain_pri_table = (void *)TMP;
+		lcc->lc_chain_table = (void *)TMP;
 		TMP += chains * sizeof (collate_chain_t);
 	} else
-		chain_pri_table = NULL;
-	if (info->large_count > 0)
-		large_pri_table = (void *)TMP;
+		lcc->lc_chain_table = NULL;
+	lcc->lc_chain_count = chains;
+	if (lcc->lc_large_count > 0)
+		lcc->lc_large_table = (void *)TMP;
 	else
-		large_pri_table = NULL;
+		lcc->lc_large_table = NULL;
 
-	(void) strlcpy(collate_encoding, encoding, ENCODING_LEN);
-	_collate_info = info;
-
-	if (cache)
-		(void) munmap(cache, cachesz);
-
-	cache = map;
-	cachesz = sbuf.st_size;
-	_collate_load_error = 0;
-
-	return (_LDP_LOADED);
+	return (ldata);
 }
 
-static int32_t *
-substsearch(const wchar_t key, int pass)
+static const int32_t *
+substsearch(const struct lc_collate *lcc, const wchar_t key, int pass)
 {
-	collate_subst_t *p;
-	int n = _collate_info->subst_count[pass];
+	const collate_subst_t *p;
+	int n = lcc->lc_subst_count[pass];
 
 	if (n == 0)
 		return (NULL);
 
-	if (pass >= _collate_info->directive_count)
+	if (pass >= lcc->lc_directive_count)
 		return (NULL);
 
 	if (!(key & COLLATE_SUBST_PRIORITY))
 		return (NULL);
 
-	p = subst_table[pass] + (key & ~COLLATE_SUBST_PRIORITY);
+	p = lcc->lc_subst_table[pass] + (key & ~COLLATE_SUBST_PRIORITY);
 	assert(p->key == key);
 	return (p->pri);
 }
@@ -206,7 +211,7 @@
  */
 
 static collate_chain_t *
-chainsearch(const wchar_t *key, int *len)
+chainsearch(const struct lc_collate *lcc, const wchar_t *key, int *len)
 {
 	int low;
 	int high;
@@ -214,12 +219,12 @@
 	collate_chain_t *p;
 	collate_chain_t *tab;
 
-	if (_collate_info->chain_count == 0)
+	if (lcc->lc_info->chain_count == 0)
 		return (NULL);
 
 	low = 0;
-	high = _collate_info->chain_count - 1;
-	tab = chain_pri_table;
+	high = lcc->lc_info->chain_count - 1;
+	tab = lcc->lc_chain_table;
 
 	while (low <= high) {
 		next = (low + high) / 2;
@@ -242,15 +247,15 @@
 }
 
 static collate_large_t *
-largesearch(const wchar_t key)
+largesearch(const struct lc_collate *lcc, const wchar_t key)
 {
 	int low = 0;
-	int high = _collate_info->large_count - 1;
+	int high = lcc->lc_info->large_count - 1;
 	int next, compar;
 	collate_large_t *p;
-	collate_large_t *tab = large_pri_table;
+	collate_large_t *tab = lcc->lc_large_table;
 
-	if (_collate_info->large_count == 0)
+	if (lcc->lc_info->large_count == 0)
 		return (NULL);
 
 	while (low <= high) {
@@ -268,19 +273,19 @@
 }
 
 void
-_collate_lookup(const wchar_t *t, int *len, int *pri, int which, int **state)
+_collate_lookup(const struct lc_collate *lcc, const wchar_t *t,
+    int *len, int *pri, int which, const int **state)
 {
 	collate_chain_t *p2;
 	collate_large_t *match;
-	collate_info_t *info = _collate_info;
 	int p, l;
-	int *sptr;
+	const int *sptr;
 
 	/*
 	 * If this is the "last" pass for the UNDEFINED, then
 	 * we just return the priority itself.
 	 */
-	if (which >= info->directive_count) {
+	if (which >= lcc->lc_directive_count) {
 		*pri = *t;
 		*len = 1;
 		*state = NULL;
@@ -306,7 +311,7 @@
 	 * Check for composites such as dipthongs that collate as a
 	 * single element (aka chains or collating-elements).
 	 */
-	if (((p2 = chainsearch(t, &l)) != NULL) &&
+	if (((p2 = chainsearch(lcc, t, &l)) != NULL) &&
 	    ((p = p2->pri[which]) >= 0)) {
 
 		*len = l;
@@ -318,10 +323,10 @@
 		 * Character is a small (8-bit) character.
 		 * We just look these up directly for speed.
 		 */
-		*pri = char_pri_table[*t].pri[which];
+		*pri = lcc->lc_char_table[*t].pri[which];
 
-	} else if ((info->large_count > 0) &&
-	    ((match = largesearch(*t)) != NULL)) {
+	} else if ((lcc->lc_info->large_count > 0) &&
+	    ((match = largesearch(lcc, *t)) != NULL)) {
 
 		/*
 		 * Character was found in the extended table.
@@ -332,11 +337,11 @@
 		/*
 		 * Character lacks a specific definition.
 		 */
-		if (info->directive[which] & DIRECTIVE_UNDEFINED) {
+		if (lcc->lc_directive[which] & DIRECTIVE_UNDEFINED) {
 			/* Mask off sign bit to prevent ordering confusion. */
 			*pri = (*t & COLLATE_MAX_PRIORITY);
 		} else {
-			*pri = info->undef_pri[which];
+			*pri = lcc->lc_undef_pri[which];
 		}
 		/* No substitutions for undefined characters! */
 		return;
@@ -354,7 +359,7 @@
 	 * to be substituted be unique for that level.  The localedef
 	 * code ensures this for us.
 	 */
-	if ((sptr = substsearch(*pri, which)) != NULL) {
+	if ((sptr = substsearch(lcc, *pri, which)) != NULL) {
 		if ((*pri = *sptr) != 0) {
 			sptr++;
 			*state = *sptr ? sptr : NULL;
@@ -368,7 +373,8 @@
  * NOT NULL terminate.  That is left to the caller.
  */
 size_t
-_collate_wxfrm(const wchar_t *src, wchar_t *xf, size_t room)
+_collate_wxfrm(const struct lc_collate *lcc, const wchar_t *src, wchar_t *xf,
+    size_t room)
 {
 	int		pri;
 	int		len;
@@ -376,13 +382,14 @@
 	wchar_t		*tr = NULL;
 	int		direc;
 	int		pass;
-	int32_t 	*state;
+	const int32_t 	*state;
 	size_t		want = 0;
 	size_t		need = 0;
+	int		ndir = lcc->lc_directive_count;
 
 	assert(src);
 
-	for (pass = 0; pass <= _collate_info->directive_count; pass++) {
+	for (pass = 0; pass <= ndir; pass++) {
 
 		state = NULL;
 
@@ -396,10 +403,10 @@
 		}
 
 		/* special pass for undefined */
-		if (pass == _collate_info->directive_count) {
+		if (pass == ndir) {
 			direc = DIRECTIVE_FORWARD | DIRECTIVE_UNDEFINED;
 		} else {
-			direc = _collate_info->directive[pass];
+			direc = lcc->lc_directive[pass];
 		}
 
 		t = src;
@@ -424,7 +431,8 @@
 
 		if (direc & DIRECTIVE_POSITION) {
 			while (*t || state) {
-				_collate_lookup(t, &len, &pri, pass, &state);
+				_collate_lookup(lcc, t, &len, &pri, pass,
+				    &state);
 				t += len;
 				if (pri <= 0) {
 					if (pri < 0) {
@@ -442,7 +450,8 @@
 			}
 		} else {
 			while (*t || state) {
-				_collate_lookup(t, &len, &pri, pass, &state);
+				_collate_lookup(lcc, t, &len, &pri, pass,
+				    &state);
 				t += len;
 				if (pri <= 0) {
 					if (pri < 0) {
@@ -497,10 +506,10 @@
 #define	XFRM_SEP	('.')	/* chosen to be less than XFRM_OFFSET */
 
 static int
-xfrm(unsigned char *p, int pri, int pass)
+xfrm(locale_t loc, unsigned char *p, int pri, int pass)
 {
 	/* we use unsigned to ensure zero fill on right shift */
-	uint32_t val = (uint32_t)_collate_info->pri_count[pass];
+	uint32_t val = (uint32_t)loc->collate->lc_pri_count[pass];
 	int nc = 0;
 
 	while (val) {
@@ -514,7 +523,7 @@
 }
 
 size_t
-_collate_sxfrm(const wchar_t *src, char *xf, size_t room)
+_collate_sxfrm(const wchar_t *src, char *xf, size_t room, locale_t loc)
 {
 	int		pri;
 	int		len;
@@ -522,15 +531,17 @@
 	wchar_t		*tr = NULL;
 	int		direc;
 	int		pass;
-	int32_t 	*state;
+	const int32_t 	*state;
 	size_t		want = 0;
 	size_t		need = 0;
 	int		b;
 	uint8_t		buf[XFRM_BYTES];
+	const struct lc_collate *lcc = loc->collate;
+	int		ndir = lcc->lc_directive_count;
 
 	assert(src);
 
-	for (pass = 0; pass <= _collate_info->directive_count; pass++) {
+	for (pass = 0; pass <= ndir; pass++) {
 
 		state = NULL;
 
@@ -544,10 +555,10 @@
 		}
 
 		/* special pass for undefined */
-		if (pass == _collate_info->directive_count) {
+		if (pass == ndir) {
 			direc = DIRECTIVE_FORWARD | DIRECTIVE_UNDEFINED;
 		} else {
-			direc = _collate_info->directive[pass];
+			direc = lcc->lc_directive[pass];
 		}
 
 		t = src;
@@ -573,7 +584,8 @@
 		if (direc & DIRECTIVE_POSITION) {
 			while (*t || state) {
 
-				_collate_lookup(t, &len, &pri, pass, &state);
+				_collate_lookup(lcc, t, &len, &pri, pass,
+				    &state);
 				t += len;
 				if (pri <= 0) {
 					if (pri < 0) {
@@ -583,7 +595,7 @@
 					pri = COLLATE_MAX_PRIORITY;
 				}
 
-				b = xfrm(buf, pri, pass);
+				b = xfrm(loc, buf, pri, pass);
 				want += b;
 				if (room) {
 					while (b) {
@@ -598,7 +610,8 @@
 			}
 		} else {
 			while (*t || state) {
-				_collate_lookup(t, &len, &pri, pass, &state);
+				_collate_lookup(lcc, t, &len, &pri, pass,
+				    &state);
 				t += len;
 				if (pri <= 0) {
 					if (pri < 0) {
@@ -608,7 +621,7 @@
 					continue;
 				}
 
-				b = xfrm(buf, pri, pass);
+				b = xfrm(loc, buf, pri, pass);
 				want += b;
 				if (room) {
 
--- old/usr/src/lib/libc/port/locale/collate.h	Tue May 20 07:58:46 2014
+++ new/usr/src/lib/libc/port/locale/collate.h	Tue May 20 07:58:46 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systmes, Inc.  All rights reserved.
  * Copyright (c) 1995 Alex Tatmanjants <alex@elvisti.kiev.ua>
  *		at Electronni Visti IA, Kiev, Ukraine.
@@ -31,6 +32,8 @@
 
 #include <sys/types.h>
 #include <limits.h>
+#include <locale.h>
+#include "localeimpl.h"
 
 #define	COLLATE_STR_LEN		24		/* should be 64-bit multiple */
 #define	COLLATE_VERSION		"IllumosCollate2\n"
@@ -92,14 +95,30 @@
 	int32_t pri[COLLATE_STR_LEN];
 } collate_subst_t;
 
-int	_collate_load_tables(const char *);
-void	_collate_lookup(const wchar_t *, int *, int *, int, int **);
-size_t	_collate_wxfrm(const wchar_t *, wchar_t *, size_t);
-size_t	_collate_sxfrm(const wchar_t *, char *, size_t);
-int	_collate_range_cmp(wchar_t, wchar_t);
+struct lc_collate {
+	int		lc_is_posix;
 
-extern int _collate_load_error;
-extern int _collate_substitute_nontrivial;
-extern collate_info_t *_collate_info;
+	uint8_t		lc_directive_count;
+	uint8_t		lc_directive[COLL_WEIGHTS_MAX];
+	int32_t		lc_pri_count[COLL_WEIGHTS_MAX];
+	int32_t		lc_flags;
+	int32_t		lc_chain_count;
+	int32_t		lc_large_count;
+	int32_t		lc_subst_count[COLL_WEIGHTS_MAX];
+	int32_t		lc_undef_pri[COLL_WEIGHTS_MAX];
 
+	collate_info_t	*lc_info;
+	collate_char_t	*lc_char_table;
+	collate_large_t	*lc_large_table;
+	collate_chain_t	*lc_chain_table;
+	collate_subst_t	*lc_subst_table[COLL_WEIGHTS_MAX];
+};
+
+void	_collate_lookup(const struct lc_collate *, const wchar_t *,
+    int *, int *, int, const int **);
+size_t	_collate_wxfrm(const struct lc_collate *, const wchar_t *,
+    wchar_t *, size_t);
+size_t	_collate_sxfrm(const wchar_t *, char *, size_t, locale_t);
+int	_collate_range_cmp(wchar_t, wchar_t, locale_t);
+
 #endif /* !_COLLATE_H_ */
--- old/usr/src/lib/libc/port/locale/collcmp.c	Tue May 20 07:58:46 2014
+++ new/usr/src/lib/libc/port/locale/collcmp.c	Tue May 20 07:58:46 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright (C) 1996 by Andrey A. Chernov, Moscow, Russia.
  * All rights reserved.
  *
@@ -30,15 +31,17 @@
 #include "collate.h"
 
 /*
- * Compare two characters using collate
+ * Compare two characters using collate - thread safe.
  */
 
 int
-_collate_range_cmp(wchar_t c1, wchar_t c2)
+_collate_range_cmp(wchar_t c1, wchar_t c2, locale_t loc)
 {
-	static wchar_t s1[2], s2[2];
+	wchar_t s1[2], s2[2];
 
 	s1[0] = c1;
+	s1[1] = 0;
 	s2[0] = c2;
-	return (wcscoll(s1, s2));
+	s2[1] = 0;
+	return (wcscoll_l(s1, s2, loc));
 }
